<?php

namespace Kahanit\TableRateShipping\Model;

// inheritance
use Magento\Framework\Model\AbstractModel;
use Magento\Framework\DataObject\IdentityInterface;

class CarrierTableRateMethod extends AbstractModel implements IdentityInterface
{
    const CACHE_TAG = 'kahanit_carrier_table_rate_method';
    protected $_cacheTag = 'kahanit_carrier_table_rate_method';
    protected $_eventPrefix = 'kahanit_carrier_table_rate_method';
    /* table columns */
    const ID_CARRIER = 'id_carrier';
    const ID_SHOP = 'id_shop';
    const CARRIER_NAME = 'carrier_name';
    const METHOD_NAME = 'method_name';

    protected function _construct()
    {
        $this->_init('Kahanit\TableRateShipping\Model\ResourceModel\CarrierTableRateMethod');
    }

    public function getIdentities()
    {
        return [self::CACHE_TAG . '_' . $this->getId()];
    }

    public function getId()
    {
        if (!is_numeric($this->getData(self::ID_CARRIER))) {
            return $this->getData(self::ID_CARRIER);
        }

        return (int)$this->getData(self::ID_CARRIER);
    }

    public function getIdShop()
    {
        return (int)$this->getData(self::ID_SHOP);
    }

    public function getCarrierName()
    {
        return $this->getData(self::CARRIER_NAME);
    }

    public function getMethodName()
    {
        return $this->getData(self::METHOD_NAME);
    }

    public function setId($id)
    {
        return $this->setData(self::ID_CARRIER, (int)$id);
    }

    public function setIdShop($id_shop)
    {
        return $this->setData(self::ID_SHOP, (int)$id_shop);
    }

    public function setCarrierName($carrier_name)
    {
        return $this->setData(self::CARRIER_NAME, $carrier_name);
    }

    public function setMethodName($method_name)
    {
        return $this->setData(self::METHOD_NAME, $method_name);
    }
}
