<?php

namespace Kahanit\TableRateShipping\Model;

// inheritance
use Magento\Framework\Model\AbstractModel;
use Magento\Framework\DataObject\IdentityInterface;

class CarrierTableRateProduct extends AbstractModel implements IdentityInterface
{
    const CACHE_TAG = 'kahanit_carrier_table_rate_product';
    protected $_cacheTag = 'kahanit_carrier_table_rate_product';
    protected $_eventPrefix = 'kahanit_carrier_table_rate_product';
    /* table fields */
    const ID_CARRIER_PRODUCT = 'id_carrier_product';
    const ID_SHOP = 'id_shop';
    const ID_CARRIER = 'id_carrier';
    const ID_PRODUCT = 'id_product';

    protected function _construct()
    {
        $this->_init('Kahanit\TableRateShipping\Model\ResourceModel\CarrierTableRateProduct');
    }

    public function getIdentities()
    {
        return [self::CACHE_TAG . '_' . $this->getId()];
    }

    public function getId()
    {
        if (!is_numeric($this->getData(self::ID_CARRIER_PRODUCT))) {
            return $this->getData(self::ID_CARRIER_PRODUCT);
        }

        return (int)$this->getData(self::ID_CARRIER_PRODUCT);
    }

    public function getIdShop()
    {
        return (int)$this->getData(self::ID_SHOP);
    }

    public function getIdCarrier()
    {
        return (int)$this->getData(self::ID_CARRIER);
    }

    public function getIdProduct()
    {
        return (int)$this->getData(self::ID_PRODUCT);
    }

    public function setId($id)
    {
        return $this->setData(self::ID_CARRIER_PRODUCT, (int)$id);
    }

    public function setIdShop($id_shop)
    {
        return $this->setData(self::ID_SHOP, (int)$id_shop);
    }

    public function setIdCarrier($id_carrier)
    {
        return $this->setData(self::ID_CARRIER, (int)$id_carrier);
    }

    public function setIdProduct($id_product)
    {
        return $this->setData(self::ID_PRODUCT, (int)$id_product);
    }
}
