<?php

namespace Kahanit\TableRateShipping\Model;

// inheritance
use Magento\Framework\Model\AbstractModel;
use Magento\Framework\DataObject\IdentityInterface;

class CarrierTableRateZone extends AbstractModel implements IdentityInterface
{
    const CACHE_TAG = 'kahanit_carrier_table_rate_zone';
    protected $_cacheTag = 'kahanit_carrier_table_rate_zone';
    protected $_eventPrefix = 'kahanit_carrier_table_rate_zone';
    /* table fields */
    const ID_ZONE = 'id_zone';
    const ID_SHOP = 'id_shop';
    const NAME = 'name';

    protected function _construct()
    {
        $this->_init('Kahanit\TableRateShipping\Model\ResourceModel\CarrierTableRateZone');
    }

    public function getIdentities()
    {
        return [self::CACHE_TAG . '_' . $this->getId()];
    }

    public function getId()
    {
        if (!is_numeric($this->getData(self::ID_ZONE))) {
            return $this->getData(self::ID_ZONE);
        }

        return (int)$this->getData(self::ID_ZONE);
    }

    public function getIdShop()
    {
        return (int)$this->getData(self::ID_SHOP);
    }

    public function getName()
    {
        return $this->getData(self::NAME);
    }

    public function setId($id)
    {
        return $this->setData(self::ID_ZONE, (int)$id);
    }

    public function setIdShop($id_shop)
    {
        return $this->setData(self::ID_SHOP, (int)$id_shop);
    }

    public function setName($name)
    {
        return $this->setData(self::NAME, $name);
    }
}
