<?php

namespace Kahanit\TableRateShipping\Observer;

// inheritance
use Magento\Framework\Event\ObserverInterface;
// injection
use Kahanit\TableRateShipping\Model\CarrierTableRateProductFactory;
// other
use Magento\Framework\Event\Observer;

class DeleteCarrierProductByProductObserver implements ObserverInterface
{
    protected $carrierTableRateProductFactory;

    public function __construct(
        CarrierTableRateProductFactory $carrierTableRateProductFactory
    ) {
        $this->carrierTableRateProductFactory = $carrierTableRateProductFactory;
    }

    public function execute(Observer $observer)
    {
        $this->carrierTableRateProductFactory->create()->getResource()->deleteByProduct($observer->getProduct()->getId());
    }
}
