<?php

namespace Kahanit\TableRateShipping\Setup;

// inheritance
use Magento\Framework\Setup\InstallSchemaInterface;
// other
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\DB\Ddl\Table;

class InstallSchema implements InstallSchemaInterface
{
    public function install(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $installer = $setup;
        $installer->startSetup();
        $connection = $installer->getConnection();

        $sql = $connection->newTable($installer->getTable('carrier_table_rate'));
        $sql->addColumn('id_carrier_table_rate', Table::TYPE_BIGINT, 20, ['nullable' => false, 'unsigned' => true, 'primary' => true, 'identity' => true], 'Id_carrier_table_rate');
        $sql->addColumn('id_shop', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Id_shop');
        $sql->addColumn('id_carrier', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Id_carrier');
        $sql->addColumn('id_zone', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Id_zone');
        $sql->addColumn('id_group', Table::TYPE_BIGINT, 20, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Id_group');
        $sql->addColumn('id_country', Table::TYPE_TEXT, 2, ['nullable' => false, 'default' => '0'], 'Id_country');
        $sql->addColumn('id_state', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Id_state');
        $sql->addColumn('dest_city', Table::TYPE_TEXT, 64, ['nullable' => false, 'default' => ''], 'Dest_city');
        $sql->addColumn('dest_zip', Table::TYPE_TEXT, 25, ['nullable' => false, 'default' => ''], 'Dest_zip');
        $sql->addColumn('condition_weight_from', Table::TYPE_DECIMAL, '12,6', ['nullable' => false, 'default' => '0.000000'], 'Condition_weight_from');
        $sql->addColumn('condition_weight_to', Table::TYPE_DECIMAL, '12,6', ['nullable' => false, 'default' => '0.000000'], 'Condition_weight_to');
        $sql->addColumn('condition_price_from', Table::TYPE_DECIMAL, '12,6', ['nullable' => false, 'default' => '0.000000'], 'Condition_price_from');
        $sql->addColumn('condition_price_to', Table::TYPE_DECIMAL, '12,6', ['nullable' => false, 'default' => '0.000000'], 'Condition_price_to');
        $sql->addColumn('condition_ptprice_from', Table::TYPE_DECIMAL, '12,6', ['nullable' => false, 'default' => '0.000000'], 'Condition_ptprice_from');
        $sql->addColumn('condition_ptprice_to', Table::TYPE_DECIMAL, '12,6', ['nullable' => false, 'default' => '0.000000'], 'Condition_ptprice_to');
        $sql->addColumn('condition_quantity_from', Table::TYPE_DECIMAL, '12,6', ['nullable' => false, 'default' => '0.000000'], 'Condition_quantity_from');
        $sql->addColumn('condition_quantity_to', Table::TYPE_DECIMAL, '12,6', ['nullable' => false, 'default' => '0.000000'], 'Condition_quantity_to');
        $sql->addColumn('condition_volume_from', Table::TYPE_DECIMAL, '12,6', ['nullable' => false, 'default' => '0.000000'], 'Condition_volume_from');
        $sql->addColumn('condition_volume_to', Table::TYPE_DECIMAL, '12,6', ['nullable' => false, 'default' => '0.000000'], 'Condition_volume_to');
        $sql->addColumn('price', Table::TYPE_TEXT, '64k', ['nullable' => false, 'default' => ''], 'Price');
        $sql->addColumn('comment', Table::TYPE_TEXT, '64k', ['nullable' => false, 'default' => ''], 'Comment');
        $sql->addColumn('active', Table::TYPE_SMALLINT, null, ['nullable' => false, 'unsigned' => true, 'default' => '1'], 'Active');
        $sql->addColumn('order', Table::TYPE_BIGINT, 20, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Order');
        $connection->createTable($sql);

        $sql = $connection->newTable($installer->getTable('carrier_table_rate_method'));
        $sql->addColumn('id_carrier', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'primary' => true, 'identity' => true], 'Id_carrier');
        $sql->addColumn('id_shop', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Id_shop');
        $sql->addColumn('carrier_name', Table::TYPE_TEXT, 255, ['nullable' => false, 'default' => ''], 'Carrier_name');
        $sql->addColumn('method_name', Table::TYPE_TEXT, 255, ['nullable' => false, 'default' => ''], 'Method_name');
        $connection->createTable($sql);

        $sql = $connection->newTable($installer->getTable('carrier_table_rate_product'));
        $sql->addColumn('id_carrier_product', Table::TYPE_BIGINT, 20, ['nullable' => false, 'unsigned' => true, 'primary' => true, 'identity' => true], 'Id_carrier_product');
        $sql->addColumn('id_shop', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Id_shop');
        $sql->addColumn('id_carrier', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Id_carrier');
        $sql->addColumn('id_product', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Id_product');
        $connection->createTable($sql);

        $sql = $connection->newTable($installer->getTable('carrier_table_rate_zone'));
        $sql->addColumn('id_zone', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'primary' => true, 'identity' => true], 'Id_zone');
        $sql->addColumn('id_shop', Table::TYPE_INTEGER, null, ['nullable' => false, 'unsigned' => true, 'default' => '0'], 'Id_shop');
        $sql->addColumn('name', Table::TYPE_TEXT, 255, ['nullable' => false, 'default' => ''], 'Name');
        $connection->createTable($sql);

        $installer->endSetup();
    }
}
