<?php

namespace Kahanit\TableRateShipping\Setup;

// inheritance
use Magento\Framework\Setup\UpgradeSchemaInterface;
// other
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\DB\Ddl\Table;

class UpgradeSchema implements UpgradeSchemaInterface
{
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $installer = $setup;
        $installer->startSetup();
        $connection = $installer->getConnection();

        if (version_compare($context->getVersion(), '2.0.1', '<')) {
            // alter table to add id_group column
            $connection->addColumn(
                $installer->getTable('carrier_table_rate'),
                'id_group',
                [
                    'type' => Table::TYPE_BIGINT,
                    'length' => 20,
                    'nullable' => false,
                    'unsigned' => true,
                    'default' => '0',
                    'after' => 'id_zone',
                    'comment' => 'Id_group'
                ]
            );
        }

        $installer->endSetup();
    }
}
